#!/usr/bin/perl

# Little perl to handle deny and build pix syslogs and turn them both into doomcube 
# output

use strict;

# Make the stdout 'hot'
my $ofh = select STDOUT;
$| = 1;
select $ofh;

while (<STDIN>) {
    if (/Built outbound [TU]CP connection \d+ for outside:(\d+)\.(\d+)\.(\d+)\.(\d+)\/\d+ \(\d+\.\d+\.\d+\.\d+\/\d+\) to [A-Za-z0-9]+:10\.\d+\.\d+\.\d+\/\d+ \((\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+)\)/) {
		print "$1.$2.$3.$4 $5.$6.$7.$8 $9\n";
    } elsif (/Built outbound [TU]CP connection \d+ for outside:(\d+)\.(\d+)\.(\d+)\.(\d+)\/\d+ \(\d+\.\d+\.\d+\.\d+\/\d+\) to [A-Za-z0-9]+:(\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+)/) {
		print "$1.$2.$3.$4 $5.$6.$7.$8 $9\n";
    } elsif (/Built inbound [TU]CP connection \d+ for outside:(\d+)\.(\d+)\.(\d+)\.(\d+)\/\d+ \(\d+\.\d+\.\d+\.\d+\/\d+\) to [A-Za-z0-9]+:10\.\d+\.\d+\.\d+\/\d+ \((\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+)\)/) {
		print "$1.$2.$3.$4 $5.$6.$7.$8 $9\n";
	} elsif (/Built inbound [TU]CP connection \d+ for outside:(\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+) \(\d+\.\d+\.\d+\.\d+\/\d+\) to [A-Za-z0-9]+:(\d+)\.(\d+)\.(\d+)\.(\d+)\/\d+/) {
		print "$1.$2.$3.$4 $6.$7.$8.$9 $5\n";
	} elsif (/Deny tcp src outside:(\d+)\.(\d+)\.(\d+)\.(\d+)\/\d+ dst inside:(\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+)/) {
		print "$1.$2.$3.$4 $5.$6.$7.$8 $9\n";
	} elsif (/Teardown TCP connection \d+ for outside:(\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+) \(\d+\.\d+\.\d+\.\d+\/\d+\) to [A-Za-z0-9]+:(\d+)\.(\d+)\.(\d+)\.(\d+)\/\d+/) {
		print "$1.$2.$3.$4 $6.$7.$8.$9 $5\n";
    }
}

